﻿/**************************************************************************************
 **                                                                                  **
 **   Le Converleeter, créé par Moonlight Dreamer.                                   **
 **                                                                                  **
 **   ----------------------------------------------------------------------------   **
 **                                                                                  **
 **   Copyright (c) 2011 ANDRE Guillaume                                             **
 **   All rights reserved.                                                           **
 **                                                                                  **
 **   Redistribution and use in source and binary forms, with or                     **
 **   without modification, are permitted provided that the following                **
 **   conditions are met:                                                            **
 **                                                                                  **
 **   Redistributions of source code must retain the above copyright                 **
 **   notice, this list of conditions and the following disclaimer.                  **
 **   Redistributions in binary form must reproduce the above copyright              **
 **   notice, this list of conditions and the following disclaimer in                **
 **   the documentation and/or other materials provided with the distribution.       **
 **   Neither the name of the copyright holder nor the names of its                  **
 **   contributors may be used to endorse or promote products derived from           **
 **   this software without specific prior written permission.                       **
 **                                                                                  **
 **   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS            **
 **   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT              **
 **   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS              **
 **   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT       **
 **   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,          **
 **   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED       **
 **   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,            **
 **   OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY         **
 **   OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING        **
 **   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,   **
 **   EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                             **
 **                                                                                  **
 **************************************************************************************/


#include "conversions.h"

QString tradEnLeet(QString const& texteEntre, char const perso, bool const doublerSlash, bool const mettreEspaces, QLineEdit **alphabet)
{
    QString texteTraduit("");
    QString const accents("ȧāąćĉċčȩėēẽĝĥiīĩĵjĺļłńǹņṅȯōřśŝşṡšẗţṫūũŭýỳŷÿẏȳỹźżžœŒ");

    for(int i(0) ; i < texteEntre.size() ; i++)
    {
        if(texteEntre[i] == 'a' || texteEntre[i] == 224 || texteEntre[i] == 225
           || texteEntre[i] == 226 || texteEntre[i] == 227 || texteEntre[i] == 228 || texteEntre[i] == 229
           || texteEntre[i] == accents[0] || texteEntre[i] == accents[1] || texteEntre[i] == accents[2]
           || texteEntre[i] == 'A' || texteEntre[i] == 192 || texteEntre[i] == 193
           || texteEntre[i] == 194 || texteEntre[i] == 195 || texteEntre[i] == 196
           || texteEntre[i] == 197 || texteEntre[i] == accents[0].toUpper()
           || texteEntre[i] == accents[1].toUpper() || texteEntre[i] == accents[2].toUpper())
        {
            if(perso == 1 || perso == 2)
            {
                if(doublerSlash)
                  texteTraduit += "/-\\\\";
                else
                  texteTraduit += "/-\\";
            }

            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, A);
                else
                  texteTraduit += alphabet[A]->text();
            }
        }

        else if(texteEntre[i] == 'b' || texteEntre[i] == 'B')
        {
            if(perso == 1)
              texteTraduit += '8';
            else if(perso == 2)
              texteTraduit += "|3";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, B);
                else if(!doublerSlash)
                  texteTraduit += alphabet[B]->text();
            }
        }

        else if(texteEntre[i] == 'c' || texteEntre[i] == 231 || texteEntre[i] == accents[3]
           || texteEntre[i] == accents[4] || texteEntre[i] == accents[5] || texteEntre[i] == accents[6]
           || texteEntre[i] == 'C' || texteEntre[i] == 199 || texteEntre[i] == accents[3].toUpper()
           || texteEntre[i] == accents[4].toUpper() || texteEntre[i] == accents[5].toUpper()
           || texteEntre[i] == accents[6].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += '(';
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, C);
                else
                  texteTraduit += alphabet[C]->text();
            }
        }

        else if(texteEntre[i] == 'd' || texteEntre[i] == 'D' || texteEntre[i] == 208)
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "|)";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, D);
                else
                  texteTraduit += alphabet[D]->text();
            }
        }

        else if(texteEntre[i] == 'e' || texteEntre[i] == 232 || texteEntre[i] == 233 || texteEntre[i] == 234
           || texteEntre[i] == 235 || texteEntre[i] == accents[7] || texteEntre[i] == accents[8]
           || texteEntre[i] == accents[9] || texteEntre[i] == accents[10]
           || texteEntre[i] == 'E' || texteEntre[i] == 200 || texteEntre[i] == 201
           || texteEntre[i] == 202 || texteEntre[i] == 203 || texteEntre[i] == accents[7].toUpper()
           || texteEntre[i] == accents[8].toUpper() || texteEntre[i] == accents[9].toUpper()
           || texteEntre[i] == accents[10].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += '3';
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, E);
                else
                  texteTraduit += alphabet[E]->text();
            }
        }

        else if(texteEntre[i] == 'f' || texteEntre[i] == 'F')
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "|=";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, F);
                else
                  texteTraduit += alphabet[F]->text();
            }
        }

        else if(texteEntre[i] == 'g' || texteEntre[i] == accents[11]
           || texteEntre[i] == 'G' || texteEntre[i] == accents[11].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += '6';
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, G);
                else
                  texteTraduit += alphabet[G]->text();
            }
        }

        else if(texteEntre[i] == 'h' || texteEntre[i] == accents[12]
           || texteEntre[i] == 'H' || texteEntre[i] == accents[12].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "|-|";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, H);
                else
                  texteTraduit += alphabet[H]->text();
            }
        }

        else if(texteEntre[i] == 'i' || texteEntre[i] == 236 || texteEntre[i] == 237 || texteEntre[i] == 238
           || texteEntre[i] == 239 || texteEntre[i] == accents[14] || texteEntre[i] == accents[15]
           || texteEntre[i] == 'I' || texteEntre[i] == 204 || texteEntre[i] == 205 || texteEntre[i] == 206
           || texteEntre[i] == 207 || texteEntre[i] == accents[13].toUpper()
           || texteEntre[i] == accents[14].toUpper() || texteEntre[i] == accents[15].toUpper())
        {
            if(perso == 1)
              texteTraduit += '!';
            else if(perso == 2)
              texteTraduit += '|';
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, I);
                else if(!doublerSlash)
                  texteTraduit += alphabet[I]->text();
            }
        }

        else if(texteEntre[i] == 'j' || texteEntre[i] == accents[16]
           || texteEntre[i] == 'J' || texteEntre[i] == accents[16].toUpper()
           || texteEntre[i] == accents[17].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "_|";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, J);
                else
                  texteTraduit += alphabet[J]->text();
            }
        }

        else if(texteEntre[i] == 'k' || texteEntre[i] == 'K')
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "|<";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, K);
                else
                  texteTraduit += alphabet[K]->text();
            }
        }

        else if(texteEntre[i] == 'l' || texteEntre[i] == accents[18]
           || texteEntre[i] == accents[19] || texteEntre[i] == accents[20]
           || texteEntre[i] == 'L' || texteEntre[i] == accents[18].toUpper()
           || texteEntre[i] == accents[19].toUpper() || texteEntre[i] == accents[20].toUpper())
        {
            if(perso == 1)
              texteTraduit += '1';
            else if(perso == 2)
              texteTraduit += "|_";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, L);
                else if(!doublerSlash)
                  texteTraduit += alphabet[L]->text();
            }
        }

        else if(texteEntre[i] == 'm' || texteEntre[i] == 'M')
        {
            if(perso == 1 || perso == 2)
            {
                if(doublerSlash)
                  texteTraduit += "|\\\\/|";
                else
                  texteTraduit += "|\\/|";
            }

            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, M);
                else
                  texteTraduit += alphabet[M]->text();
            }
        }

        else if(texteEntre[i] == 'n' || texteEntre[i] == 241 || texteEntre[i] == accents[21]
           || texteEntre[i] == accents[22] || texteEntre[i] == accents[23] || texteEntre[i] == accents[24]
           || texteEntre[i] == 'N' || texteEntre[i] == 209 || texteEntre[i] == accents[16].toUpper()
           || texteEntre[i] == accents[22].toUpper() || texteEntre[i] == accents[23].toUpper()
           || texteEntre[i] == accents[24].toUpper())
        {
            if(perso == 1 || perso == 2)
            {
                if(doublerSlash)
                  texteTraduit += "|\\\\|";
                else
                  texteTraduit += "|\\|";
            }

            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, N);
                else
                  texteTraduit += alphabet[N]->text();
            }
        }

        else if(texteEntre[i] == 'o' || texteEntre[i] == 240 || texteEntre[i] == 242 || texteEntre[i] == 243
           || texteEntre[i] == 244 || texteEntre[i] == 245 || texteEntre[i] == 246 || texteEntre[i] == 248
           || texteEntre[i] == accents[25] || texteEntre[i] == accents[26]
           || texteEntre[i] == 'O' || texteEntre[i] == 210 || texteEntre[i] == 211 || texteEntre[i] == 212
           || texteEntre[i] == 213 || texteEntre[i] == 214 || texteEntre[i] == 216
           || texteEntre[i] == accents[25].toUpper() || texteEntre[i] == accents[26].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "()";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, O);
                else
                  texteTraduit += alphabet[O]->text();
            }
        }

        else if(texteEntre[i] == 'p' || texteEntre[i] == 'P')
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "|>";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, P);
                else
                  texteTraduit += alphabet[P]->text();
            }
        }

        else if(texteEntre[i] == 'q' || texteEntre[i] == 'Q')
        {
            if(perso == 1)
              texteTraduit += '9';
            else if(perso == 2)
              texteTraduit += "(,)";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, Q);
                else if(!doublerSlash)
                  texteTraduit += alphabet[Q]->text();
            }
        }

        else if(texteEntre[i] == 'r' || texteEntre[i] == accents[27]
           || texteEntre[i] == 'R' || texteEntre[i] == accents[27].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "|2";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, R);
                else
                  texteTraduit += alphabet[R]->text();
            }
        }

        else if(texteEntre[i] == 's' || texteEntre[i] == accents[28] || texteEntre[i] == accents[29]
           || texteEntre[i] == accents[30] || texteEntre[i] == accents[31] || texteEntre[i] == accents[32]
           || texteEntre[i] == 'S' || texteEntre[i] == accents[28].toUpper()
           || texteEntre[i] == accents[29].toUpper() || texteEntre[i] == accents[30].toUpper()
           || texteEntre[i] == accents[31].toUpper() || texteEntre[i] == accents[32].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += '5';
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, S);
                else
                  texteTraduit += alphabet[S]->text();
            }
        }

        else if(texteEntre[i] == 't' || texteEntre[i] == accents[33]
           || texteEntre[i] == accents[34] || texteEntre[i] == accents[35]
           || texteEntre[i] == 'T' || texteEntre[i] == accents[33].toUpper()
           || texteEntre[i] == accents[34].toUpper() || texteEntre[i] == accents[35].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += '7';
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, T);
                else
                  texteTraduit += alphabet[T]->text();
            }
        }

        else if(texteEntre[i] == 'u' || texteEntre[i] == 249 || texteEntre[i] == 250
           || texteEntre[i] == 251 || texteEntre[i] == 252 || texteEntre[i] == accents[36]
           || texteEntre[i] == accents[37] || texteEntre[i] == accents[38]
           || texteEntre[i] == 'U' || texteEntre[i] == 217 || texteEntre[i] == 218
           || texteEntre[i] == 219 || texteEntre[i] == 220 || texteEntre[i] == accents[36].toUpper()
           || texteEntre[i] == accents[37].toUpper() || texteEntre[i] == accents[38].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "|_|";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, U);
                else
                  texteTraduit += alphabet[U]->text();
            }
        }

        else if(texteEntre[i] == 'v' || texteEntre[i] == 'V')
        {
            if(perso == 1 || perso == 2)
            {
                if(doublerSlash)
                  texteTraduit += "\\\\/";
                else
                  texteTraduit += "\\/";
            }

            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, V);
                else
                  texteTraduit += alphabet[V]->text();
            }
        }

        else if(texteEntre[i] == 'w' || texteEntre[i] == 'W')
        {
            if(perso == 1 || perso == 2)
            {
                if(doublerSlash)
                  texteTraduit += "\\\\/\\\\/";
                else
                  texteTraduit += "\\/\\/";
            }

            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, W);
                else
                  texteTraduit += alphabet[W]->text();
            }
        }

        else if(texteEntre[i] == 'x' || texteEntre[i] == 'X')
        {
            if(perso == 1 || perso == 2)
              texteTraduit += ")(";
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, X);
                else
                  texteTraduit += alphabet[X]->text();
            }
        }

        else if(texteEntre[i] == 'y' || texteEntre[i] == accents[39] || texteEntre[i] == accents[40]
           || texteEntre[i] == accents[41] || texteEntre[i] == accents[42] || texteEntre[i] == accents[43]
           || texteEntre[i] == accents[44] || texteEntre[i] == accents[45]
           || texteEntre[i] == 'Y' || texteEntre[i] == accents[39].toUpper() || texteEntre[i] == accents[40].toUpper()
           || texteEntre[i] == accents[41].toUpper() || texteEntre[i] == accents[42].toUpper()
           || texteEntre[i] == accents[43].toUpper() || texteEntre[i] == accents[44].toUpper()
           || texteEntre[i] == accents[45].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += 'Y';
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, Y);
                else
                  texteTraduit += alphabet[Y]->text();
            }
        }

        else if(texteEntre[i] == 'z' || texteEntre[i] == accents[46]
           || texteEntre[i] == accents[47] || texteEntre[i] == accents[48]
           || texteEntre[i] == 'Z' || texteEntre[i] == accents[46].toUpper()
           || texteEntre[i] == accents[47].toUpper() || texteEntre[i] == accents[48].toUpper())
        {
            if(perso == 1 || perso == 2)
              texteTraduit += '2';
            else if(perso == 3)
            {
                if(doublerSlash)
                  doublerLesSlashs(alphabet, texteTraduit, Z);
                else
                  texteTraduit += alphabet[Z]->text();
            }
        }

        else if(texteEntre[i] == 230 || texteEntre[i] == 198)
        {
            if(perso == 1 || perso == 2)
            {
                if(doublerSlash)
                  texteTraduit += "/-\\\\3";
                else
                  texteTraduit += "/-\\3";
            }

            else if(perso == 3)
            {
                if(doublerSlash)
                {
                    doublerLesSlashs(alphabet, texteTraduit, A);
                    doublerLesSlashs(alphabet, texteTraduit, E);
                }

                else
                  texteTraduit += alphabet[A]->text() + alphabet[E]->text();
            }
        }

        else if(texteEntre[i] == accents[49] || texteEntre[i] == accents[50])
        {
            if(perso == 1 || perso == 2)
              texteTraduit += "()3";
            else if(perso == 3)
            {
                if(doublerSlash)
                {
                    doublerLesSlashs(alphabet, texteTraduit, O);
                    doublerLesSlashs(alphabet, texteTraduit, E);
                }

                else
                  texteTraduit += alphabet[O]->text() + alphabet[E]->text();
            }
        }

        else
          texteTraduit += texteEntre[i];

        // Ajout des espaces entre les lettres si demandé.
        if(mettreEspaces && texteEntre[i] != ' ' && texteEntre[i] != '\n' && texteEntre[i] != '\r'
           && texteEntre[i] != '\t' && i < (texteEntre.size() - 1))
          texteTraduit += ' ';
    }

    return texteTraduit;
}


QString tradEnFr(QString texteEntre, char const perso, bool const supprimerEspaces, QLineEdit **alphabet)
{
    QString texteTraduit(""), lettresAlphabet("abcdefghijklmnopqrstuvwxyz"), lettresEnLeet[26] = { "|\\/|", "\\/\\/",
    "/-\\", "|-|", "|\\|", "|_|", "|)", "|=", "_|", "|<", "()", "|>", "|2", "\\/", ")(", "8", "(", "3", "6", "!", "1",
    "9", "5", "7", "Y", "2" };
    int lettreCor(0), l(0);
    bool test(true);

    if(perso == 1)
      lettresAlphabet = "mwahnudfjkoprvxbcegilqstyz";
    else if(perso == 2)
    {
        lettresAlphabet = "mwahnqubdfjkloprvxcegistyz";
        lettresEnLeet[5] = "(,)";  lettresEnLeet[6] = "|_|";  lettresEnLeet[7] = "|3";   lettresEnLeet[8] = "|)";
        lettresEnLeet[9] = "|=";   lettresEnLeet[10] = "_|";  lettresEnLeet[11] = "|<";  lettresEnLeet[12] = "|_";
        lettresEnLeet[13] = "()";  lettresEnLeet[14] = "|>";  lettresEnLeet[15] = "|2";  lettresEnLeet[16] = "\\/";
        lettresEnLeet[17] = ")(";  lettresEnLeet[18] = "(";   lettresEnLeet[19] = "3";   lettresEnLeet[20] = "6";
        lettresEnLeet[21] = "|";
    }

    // Parcourt chaque lettre du texte entré.
    for(int i(0) ; i < texteEntre.size() ; i++)
    {
        test = true;

        // On parcourt soit les 26 cellules de LettresEnLeet, soit les 26 QLineEdits.
        for(unsigned char j(0) ; j < 26 ; j++)
        {
            lettreCor = 0;
            l = i;

            if(perso == 1 || perso == 2)
            {
                // On parcourt chaque lettre de chaque string du LettresEnleet.
                for(unsigned char k(0) ; k < lettresEnLeet[j].size() ; k++)
                {
                    if(texteEntre[l] == lettresEnLeet[j][k])
                      lettreCor++;

                    l++;
                }
            }

            else if(perso == 3)
            {
                // On parcourt chaque lettre de chaque QLineEdit.
                for(int k(0) ; k < alphabet[j]->text().size() ; k++)
                {
                    if(texteEntre[l] == alphabet[j]->text()[k])
                      lettreCor++;

                    l++;
                }
            }

            if(((perso == 1 || perso == 2) && lettreCor == lettresEnLeet[j].size())
               || (perso == 3 && lettreCor == alphabet[j]->text().size()))
            {
                if(mettreMajuscule(texteEntre, i))
                  texteTraduit += lettresAlphabet[j].toUpper();
                else
                  texteTraduit += lettresAlphabet[j];

                if(perso == 1 || perso == 2)
                {
                    for(int m(i) ; m < i + lettresEnLeet[j].size() ; m++)
                      texteEntre[m] = '\0';
                }

                else if(perso == 3)
                {
                    for(int m(i) ; m < i + alphabet[j]->text().size() ; m++)
                      texteEntre[m] = '\0';
                }

                test = false;
            }
        }

        // Suppression des espaces entre les lettres si demandé.
        if(supprimerEspaces && texteEntre[i] == ' ' && texteEntre[i + 1] != ' ')
          texteEntre[i] = '\0';

        // Si le caractère actuel ne correspond à aucune lettre.
        if(test && texteEntre[i] != '\0')
          texteTraduit += texteEntre[i];
    }

    return texteTraduit;
}


void doublerLesSlashs(QLineEdit **alphabet, QString& texteTraduit, int const j)
{
    for(int i(0) ; i < alphabet[j]->text().size() ; i++)
    {
        if(alphabet[j]->text()[i] == '\\')
          texteTraduit += alphabet[j]->text()[i];

        texteTraduit += alphabet[j]->text()[i];
    }
}


bool mettreMajuscule(QString const& texteEntre, int const i)
{
    if(i == 0)
      return true;
    else
    {
        for(int j(i - 1) ; j >= 0 ; j--)
        {
            if(texteEntre[j] != ' ' && texteEntre[j] != '.' && texteEntre[j] != '!' && texteEntre[j] != '?'
               && texteEntre[j] != '\n' && texteEntre[j] != '\r' && texteEntre[j] != '\t')
              return false;
            if(texteEntre[j] == '.' || texteEntre[j] == '!' || texteEntre[j] == '?')
              return true;
        }
    }

    return false;
}














